library IEEE, APA;
use IEEE.std_logic_1164.all;

entity APA1kx16 is

   port(DO : out std_logic_vector (15 downto 0);
      RCLOCK : in std_logic;
      WCLOCK : in std_logic;
      DI : in std_logic_vector (15 downto 0);
      WRB : in std_logic;
      RDB : in std_logic;
      WADDR : in std_logic_vector (9 downto 0);
      RADDR : in std_logic_vector (9 downto 0));

end APA1kx16;

architecture STRUCT_APA1kx16 of APA1kx16 is
component PWR
   port(Y : out std_logic);
end component;

component GND
   port(Y : out std_logic);
end component;

component RAM256x9SST
   port(RCLKS : in std_logic;
      WCLKS : in std_logic;
      DO8 : out std_logic;
      DO7 : out std_logic;
      DO6 : out std_logic;
      DO5 : out std_logic;
      DO4 : out std_logic;
      DO3 : out std_logic;
      DO2 : out std_logic;
      DO1 : out std_logic;
      DO0 : out std_logic;
      DOS : out std_logic;
      WPE : out std_logic;
      RPE : out std_logic;
      WADDR7 : in std_logic;
      WADDR6 : in std_logic;
      WADDR5 : in std_logic;
      WADDR4 : in std_logic;
      WADDR3 : in std_logic;
      WADDR2 : in std_logic;
      WADDR1 : in std_logic;
      WADDR0 : in std_logic;
      RADDR7 : in std_logic;
      RADDR6 : in std_logic;
      RADDR5 : in std_logic;
      RADDR4 : in std_logic;
      RADDR3 : in std_logic;
      RADDR2 : in std_logic;
      RADDR1 : in std_logic;
      RADDR0 : in std_logic;
      DI8 : in std_logic;
      DI7 : in std_logic;
      DI6 : in std_logic;
      DI5 : in std_logic;
      DI4 : in std_logic;
      DI3 : in std_logic;
      DI2 : in std_logic;
      DI1 : in std_logic;
      DI0 : in std_logic;
      WRB : in std_logic;
      RDB : in std_logic;
      WBLKB : in std_logic;
      RBLKB : in std_logic;
      PARODD : in std_logic;
      DIS : in std_logic);
end component;

component MUX2H
   port(Y : out std_logic;
      A : in std_logic;
      B : in std_logic;
      S : in std_logic);
end component;

component DFF
   port(Q : out std_logic;
      CLK : in std_logic;
      D : in std_logic);
end component;

component OR2
   port(Y : out std_logic;
      A : in std_logic;
      B : in std_logic);
end component;

component NAND2FT
   port(Y : out std_logic;
      A : in std_logic;
      B : in std_logic);
end component;

component NAND2
   port(Y : out std_logic;
      A : in std_logic;
      B : in std_logic);
end component;

component DMUX
   port(Y : out std_logic;
      A : in std_logic;
      B : in std_logic;
      S : in std_logic);
end component;

signal net00000, net00001, net00002, net00003, net00004, net00005, net00006, net00007, 
      net00008, net00009, net00010, net00011, net00012, net00013, net00014, net00015, 
      net00016, net00017, net00018, net00019, net00020, net00021, net00022, net00023, 
      net00024, net00025, net00026, net00027, net00028, net00029, net00030, net00031, 
      net00032, net00033, net00034, net00035, net00036, net00037, net00038, net00039, 
      net00040, net00041, net00042, net00043, net00044, net00045, net00046, net00047, 
      net00048, net00049, net00050, net00051, net00052, net00053, net00054, net00055, 
      net00056, net00057, net00058, net00059, net00060, net00061, net00062, net00063, 
      net00064, net00065, net00066, net00067, net00068, net00069, net00070, net00071, 
      net00072, net00073, net00074, net00075, net00076, net00077, net00078, net00079, 
      net00080, net00081, net00082, net00083, net00084, net00085, net00086, net00087, 
      net00088, net00089, net00090, net00091, net00092, net00093, net00094, net00095, 
      net00096, net00097, net00098, net00099, net00100, net00101, net00102, net00103, 
      net00104, net00105, net00106, net00107, net00108, net00109, net00110, net00111, 
      net00112, net00113, net00114, net00115, net00116, net00117, net00118, net00119, 
      net00120, net00121, net00122, net00123, net00124, net00125, net00126, net00127, 
      net00128, net00129, net00130, net00131, net00132, net00133, net00134, net00135, 
      net00136, net00137, net00138, net00139, net00140, net00141, net00142, net00143, 
      net00144, net00145, net00146, net00147, net00148, net00149, net00150, net00151, 
      net00152, net00153, net00154, net00155, net00156, net00157, net00158, net00159, 
      net00160, net00161, net00162, net00163, net00164, net00165, net00166, net00167, 
      net00168, net00169, net00170, net00171, net00172, net00173, net00174, net00175, 
      net00176, net00177, net00178, net00179, net00180, net00181, net00182, net00183, 
      net00184, net00185, net00186, net00187, net00188, net00189, net00190, net00191, 
      net00192, net00193, net00194, net00195, net00196, net00197, net00198, net00199, 
      net00200, net00201, net00202, net00203, net00204, net00205, net00206 : std_logic;

begin

   U1 : GND port map(Y => net00001);
   M0 : RAM256x9SST port map(RCLKS => RCLOCK, WCLKS => WCLOCK, DO8 => net00101, DO7 => net00091, DO6 => net00081, 
      DO5 => net00071, DO4 => net00061, DO3 => net00051, DO2 => net00041, DO1 => net00031, DO0 => net00017, 
      DOS => net00024, WPE => net00183, RPE => net00184, WADDR7 => WADDR(7), WADDR6 => WADDR(6), 
      WADDR5 => WADDR(5), WADDR4 => WADDR(4), WADDR3 => WADDR(3), WADDR2 => WADDR(2), 
      WADDR1 => WADDR(1), WADDR0 => WADDR(0), RADDR7 => RADDR(7), RADDR6 => RADDR(6), 
      RADDR5 => RADDR(5), RADDR4 => RADDR(4), RADDR3 => RADDR(3), RADDR2 => RADDR(2), 
      RADDR1 => RADDR(1), RADDR0 => RADDR(0), DI8 => DI(8), DI7 => DI(7), DI6 => DI(6), 
      DI5 => DI(5), DI4 => DI(4), DI3 => DI(3), DI2 => DI(2), DI1 => DI(1), 
      DI0 => DI(0), WRB => WRB, RDB => RDB, WBLKB => net00006, RBLKB => net00001, PARODD => net00001, 
      DIS => net00002);
   M1 : RAM256x9SST port map(RCLKS => RCLOCK, WCLKS => WCLOCK, DO8 => net00102, DO7 => net00092, DO6 => net00082, 
      DO5 => net00072, DO4 => net00062, DO3 => net00052, DO2 => net00042, DO1 => net00032, DO0 => net00018, 
      DOS => net00023, WPE => net00185, RPE => net00186, WADDR7 => WADDR(7), WADDR6 => WADDR(6), 
      WADDR5 => WADDR(5), WADDR4 => WADDR(4), WADDR3 => WADDR(3), WADDR2 => WADDR(2), 
      WADDR1 => WADDR(1), WADDR0 => WADDR(0), RADDR7 => RADDR(7), RADDR6 => RADDR(6), 
      RADDR5 => RADDR(5), RADDR4 => RADDR(4), RADDR3 => RADDR(3), RADDR2 => RADDR(2), 
      RADDR1 => RADDR(1), RADDR0 => RADDR(0), DI8 => DI(8), DI7 => DI(7), DI6 => DI(6), 
      DI5 => DI(5), DI4 => DI(4), DI3 => DI(3), DI2 => DI(2), DI1 => DI(1), 
      DI0 => DI(0), WRB => WRB, RDB => RDB, WBLKB => net00007, RBLKB => net00001, PARODD => net00001, 
      DIS => net00001);
   M2 : RAM256x9SST port map(RCLKS => RCLOCK, WCLKS => WCLOCK, DO8 => net00103, DO7 => net00093, DO6 => net00083, 
      DO5 => net00073, DO4 => net00063, DO3 => net00053, DO2 => net00043, DO1 => net00033, DO0 => net00019, 
      DOS => net00028, WPE => net00187, RPE => net00188, WADDR7 => WADDR(7), WADDR6 => WADDR(6), 
      WADDR5 => WADDR(5), WADDR4 => WADDR(4), WADDR3 => WADDR(3), WADDR2 => WADDR(2), 
      WADDR1 => WADDR(1), WADDR0 => WADDR(0), RADDR7 => RADDR(7), RADDR6 => RADDR(6), 
      RADDR5 => RADDR(5), RADDR4 => RADDR(4), RADDR3 => RADDR(3), RADDR2 => RADDR(2), 
      RADDR1 => RADDR(1), RADDR0 => RADDR(0), DI8 => DI(8), DI7 => DI(7), DI6 => DI(6), 
      DI5 => DI(5), DI4 => DI(4), DI3 => DI(3), DI2 => DI(2), DI1 => DI(1), 
      DI0 => DI(0), WRB => WRB, RDB => RDB, WBLKB => net00008, RBLKB => net00001, PARODD => net00001, 
      DIS => net00002);
   M3 : RAM256x9SST port map(RCLKS => RCLOCK, WCLKS => WCLOCK, DO8 => net00104, DO7 => net00094, DO6 => net00084, 
      DO5 => net00074, DO4 => net00064, DO3 => net00054, DO2 => net00044, DO1 => net00034, DO0 => net00020, 
      DOS => net00027, WPE => net00189, RPE => net00190, WADDR7 => WADDR(7), WADDR6 => WADDR(6), 
      WADDR5 => WADDR(5), WADDR4 => WADDR(4), WADDR3 => WADDR(3), WADDR2 => WADDR(2), 
      WADDR1 => WADDR(1), WADDR0 => WADDR(0), RADDR7 => RADDR(7), RADDR6 => RADDR(6), 
      RADDR5 => RADDR(5), RADDR4 => RADDR(4), RADDR3 => RADDR(3), RADDR2 => RADDR(2), 
      RADDR1 => RADDR(1), RADDR0 => RADDR(0), DI8 => DI(8), DI7 => DI(7), DI6 => DI(6), 
      DI5 => DI(5), DI4 => DI(4), DI3 => DI(3), DI2 => DI(2), DI1 => DI(1), 
      DI0 => DI(0), WRB => WRB, RDB => RDB, WBLKB => net00009, RBLKB => net00001, PARODD => net00001, 
      DIS => net00001);
   M4 : RAM256x9SST port map(RCLKS => RCLOCK, WCLKS => WCLOCK, DO8 => net00191, DO7 => net00192, DO6 => net00175, 
      DO5 => net00165, DO4 => net00155, DO3 => net00145, DO2 => net00135, DO1 => net00125, DO0 => net00111, 
      DOS => net00118, WPE => net00193, RPE => net00194, WADDR7 => WADDR(7), WADDR6 => WADDR(6), 
      WADDR5 => WADDR(5), WADDR4 => WADDR(4), WADDR3 => WADDR(3), WADDR2 => WADDR(2), 
      WADDR1 => WADDR(1), WADDR0 => WADDR(0), RADDR7 => RADDR(7), RADDR6 => RADDR(6), 
      RADDR5 => RADDR(5), RADDR4 => RADDR(4), RADDR3 => RADDR(3), RADDR2 => RADDR(2), 
      RADDR1 => RADDR(1), RADDR0 => RADDR(0), DI8 => net00001, DI7 => net00001, DI6 => DI(15), 
      DI5 => DI(14), DI4 => DI(13), DI3 => DI(12), DI2 => DI(11), DI1 => DI(10), 
      DI0 => DI(9), WRB => WRB, RDB => RDB, WBLKB => net00006, RBLKB => net00001, PARODD => net00001, 
      DIS => net00002);
   M5 : RAM256x9SST port map(RCLKS => RCLOCK, WCLKS => WCLOCK, DO8 => net00195, DO7 => net00196, DO6 => net00176, 
      DO5 => net00166, DO4 => net00156, DO3 => net00146, DO2 => net00136, DO1 => net00126, DO0 => net00112, 
      DOS => net00117, WPE => net00197, RPE => net00198, WADDR7 => WADDR(7), WADDR6 => WADDR(6), 
      WADDR5 => WADDR(5), WADDR4 => WADDR(4), WADDR3 => WADDR(3), WADDR2 => WADDR(2), 
      WADDR1 => WADDR(1), WADDR0 => WADDR(0), RADDR7 => RADDR(7), RADDR6 => RADDR(6), 
      RADDR5 => RADDR(5), RADDR4 => RADDR(4), RADDR3 => RADDR(3), RADDR2 => RADDR(2), 
      RADDR1 => RADDR(1), RADDR0 => RADDR(0), DI8 => net00001, DI7 => net00001, DI6 => DI(15), 
      DI5 => DI(14), DI4 => DI(13), DI3 => DI(12), DI2 => DI(11), DI1 => DI(10), 
      DI0 => DI(9), WRB => WRB, RDB => RDB, WBLKB => net00007, RBLKB => net00001, PARODD => net00001, 
      DIS => net00001);
   M6 : RAM256x9SST port map(RCLKS => RCLOCK, WCLKS => WCLOCK, DO8 => net00199, DO7 => net00200, DO6 => net00177, 
      DO5 => net00167, DO4 => net00157, DO3 => net00147, DO2 => net00137, DO1 => net00127, DO0 => net00113, 
      DOS => net00122, WPE => net00201, RPE => net00202, WADDR7 => WADDR(7), WADDR6 => WADDR(6), 
      WADDR5 => WADDR(5), WADDR4 => WADDR(4), WADDR3 => WADDR(3), WADDR2 => WADDR(2), 
      WADDR1 => WADDR(1), WADDR0 => WADDR(0), RADDR7 => RADDR(7), RADDR6 => RADDR(6), 
      RADDR5 => RADDR(5), RADDR4 => RADDR(4), RADDR3 => RADDR(3), RADDR2 => RADDR(2), 
      RADDR1 => RADDR(1), RADDR0 => RADDR(0), DI8 => net00001, DI7 => net00001, DI6 => DI(15), 
      DI5 => DI(14), DI4 => DI(13), DI3 => DI(12), DI2 => DI(11), DI1 => DI(10), 
      DI0 => DI(9), WRB => WRB, RDB => RDB, WBLKB => net00008, RBLKB => net00001, PARODD => net00001, 
      DIS => net00002);
   M7 : RAM256x9SST port map(RCLKS => RCLOCK, WCLKS => WCLOCK, DO8 => net00203, DO7 => net00204, DO6 => net00178, 
      DO5 => net00168, DO4 => net00158, DO3 => net00148, DO2 => net00138, DO1 => net00128, DO0 => net00114, 
      DOS => net00121, WPE => net00205, RPE => net00206, WADDR7 => WADDR(7), WADDR6 => WADDR(6), 
      WADDR5 => WADDR(5), WADDR4 => WADDR(4), WADDR3 => WADDR(3), WADDR2 => WADDR(2), 
      WADDR1 => WADDR(1), WADDR0 => WADDR(0), RADDR7 => RADDR(7), RADDR6 => RADDR(6), 
      RADDR5 => RADDR(5), RADDR4 => RADDR(4), RADDR3 => RADDR(3), RADDR2 => RADDR(2), 
      RADDR1 => RADDR(1), RADDR0 => RADDR(0), DI8 => net00001, DI7 => net00001, DI6 => DI(15), 
      DI5 => DI(14), DI4 => DI(13), DI3 => DI(12), DI2 => DI(11), DI1 => DI(10), 
      DI0 => DI(9), WRB => WRB, RDB => RDB, WBLKB => net00009, RBLKB => net00001, PARODD => net00001, 
      DIS => net00001);
   U2 : MUX2H port map(Y => net00003, A => RADDR(8), B => net00002, S => RDB);
   U3 : DFF port map(Q => net00002, CLK => RCLOCK, D => net00003);
   U4 : MUX2H port map(Y => net00005, A => RADDR(9), B => net00004, S => RDB);
   U5 : DFF port map(Q => net00004, CLK => RCLOCK, D => net00005);
   U6 : OR2 port map(Y => net00006, A => WADDR(8), B => WADDR(9));
   U7 : NAND2FT port map(Y => net00007, A => WADDR(9), B => WADDR(8));
   U8 : NAND2FT port map(Y => net00008, A => WADDR(8), B => WADDR(9));
   U9 : NAND2 port map(Y => net00009, A => WADDR(8), B => WADDR(9));
   U14 : DMUX port map(Y => net00022, A => net00018, B => net00001, S => net00023);
   U15 : DMUX port map(Y => net00021, A => net00017, B => net00022, S => net00024);
   U16 : DMUX port map(Y => net00026, A => net00020, B => net00001, S => net00027);
   U17 : DMUX port map(Y => net00025, A => net00019, B => net00026, S => net00028);
   U18 : MUX2H port map(Y => DO(0), A => net00021, B => net00025, S => net00004);
   U19 : DMUX port map(Y => net00036, A => net00032, B => net00001, S => net00023);
   U20 : DMUX port map(Y => net00035, A => net00031, B => net00036, S => net00024);
   U21 : DMUX port map(Y => net00038, A => net00034, B => net00001, S => net00027);
   U22 : DMUX port map(Y => net00037, A => net00033, B => net00038, S => net00028);
   U23 : MUX2H port map(Y => DO(1), A => net00035, B => net00037, S => net00004);
   U24 : DMUX port map(Y => net00046, A => net00042, B => net00001, S => net00023);
   U25 : DMUX port map(Y => net00045, A => net00041, B => net00046, S => net00024);
   U26 : DMUX port map(Y => net00048, A => net00044, B => net00001, S => net00027);
   U27 : DMUX port map(Y => net00047, A => net00043, B => net00048, S => net00028);
   U28 : MUX2H port map(Y => DO(2), A => net00045, B => net00047, S => net00004);
   U29 : DMUX port map(Y => net00056, A => net00052, B => net00001, S => net00023);
   U30 : DMUX port map(Y => net00055, A => net00051, B => net00056, S => net00024);
   U31 : DMUX port map(Y => net00058, A => net00054, B => net00001, S => net00027);
   U32 : DMUX port map(Y => net00057, A => net00053, B => net00058, S => net00028);
   U33 : MUX2H port map(Y => DO(3), A => net00055, B => net00057, S => net00004);
   U34 : DMUX port map(Y => net00066, A => net00062, B => net00001, S => net00023);
   U35 : DMUX port map(Y => net00065, A => net00061, B => net00066, S => net00024);
   U36 : DMUX port map(Y => net00068, A => net00064, B => net00001, S => net00027);
   U37 : DMUX port map(Y => net00067, A => net00063, B => net00068, S => net00028);
   U38 : MUX2H port map(Y => DO(4), A => net00065, B => net00067, S => net00004);
   U39 : DMUX port map(Y => net00076, A => net00072, B => net00001, S => net00023);
   U40 : DMUX port map(Y => net00075, A => net00071, B => net00076, S => net00024);
   U41 : DMUX port map(Y => net00078, A => net00074, B => net00001, S => net00027);
   U42 : DMUX port map(Y => net00077, A => net00073, B => net00078, S => net00028);
   U43 : MUX2H port map(Y => DO(5), A => net00075, B => net00077, S => net00004);
   U44 : DMUX port map(Y => net00086, A => net00082, B => net00001, S => net00023);
   U45 : DMUX port map(Y => net00085, A => net00081, B => net00086, S => net00024);
   U46 : DMUX port map(Y => net00088, A => net00084, B => net00001, S => net00027);
   U47 : DMUX port map(Y => net00087, A => net00083, B => net00088, S => net00028);
   U48 : MUX2H port map(Y => DO(6), A => net00085, B => net00087, S => net00004);
   U49 : DMUX port map(Y => net00096, A => net00092, B => net00001, S => net00023);
   U50 : DMUX port map(Y => net00095, A => net00091, B => net00096, S => net00024);
   U51 : DMUX port map(Y => net00098, A => net00094, B => net00001, S => net00027);
   U52 : DMUX port map(Y => net00097, A => net00093, B => net00098, S => net00028);
   U53 : MUX2H port map(Y => DO(7), A => net00095, B => net00097, S => net00004);
   U54 : DMUX port map(Y => net00106, A => net00102, B => net00001, S => net00023);
   U55 : DMUX port map(Y => net00105, A => net00101, B => net00106, S => net00024);
   U56 : DMUX port map(Y => net00108, A => net00104, B => net00001, S => net00027);
   U57 : DMUX port map(Y => net00107, A => net00103, B => net00108, S => net00028);
   U58 : MUX2H port map(Y => DO(8), A => net00105, B => net00107, S => net00004);
   U59 : DMUX port map(Y => net00116, A => net00112, B => net00001, S => net00117);
   U60 : DMUX port map(Y => net00115, A => net00111, B => net00116, S => net00118);
   U61 : DMUX port map(Y => net00120, A => net00114, B => net00001, S => net00121);
   U62 : DMUX port map(Y => net00119, A => net00113, B => net00120, S => net00122);
   U63 : MUX2H port map(Y => DO(9), A => net00115, B => net00119, S => net00004);
   U64 : DMUX port map(Y => net00130, A => net00126, B => net00001, S => net00117);
   U65 : DMUX port map(Y => net00129, A => net00125, B => net00130, S => net00118);
   U66 : DMUX port map(Y => net00132, A => net00128, B => net00001, S => net00121);
   U67 : DMUX port map(Y => net00131, A => net00127, B => net00132, S => net00122);
   U68 : MUX2H port map(Y => DO(10), A => net00129, B => net00131, S => net00004);
   U69 : DMUX port map(Y => net00140, A => net00136, B => net00001, S => net00117);
   U70 : DMUX port map(Y => net00139, A => net00135, B => net00140, S => net00118);
   U71 : DMUX port map(Y => net00142, A => net00138, B => net00001, S => net00121);
   U72 : DMUX port map(Y => net00141, A => net00137, B => net00142, S => net00122);
   U73 : MUX2H port map(Y => DO(11), A => net00139, B => net00141, S => net00004);
   U74 : DMUX port map(Y => net00150, A => net00146, B => net00001, S => net00117);
   U75 : DMUX port map(Y => net00149, A => net00145, B => net00150, S => net00118);
   U76 : DMUX port map(Y => net00152, A => net00148, B => net00001, S => net00121);
   U77 : DMUX port map(Y => net00151, A => net00147, B => net00152, S => net00122);
   U78 : MUX2H port map(Y => DO(12), A => net00149, B => net00151, S => net00004);
   U79 : DMUX port map(Y => net00160, A => net00156, B => net00001, S => net00117);
   U80 : DMUX port map(Y => net00159, A => net00155, B => net00160, S => net00118);
   U81 : DMUX port map(Y => net00162, A => net00158, B => net00001, S => net00121);
   U82 : DMUX port map(Y => net00161, A => net00157, B => net00162, S => net00122);
   U83 : MUX2H port map(Y => DO(13), A => net00159, B => net00161, S => net00004);
   U84 : DMUX port map(Y => net00170, A => net00166, B => net00001, S => net00117);
   U85 : DMUX port map(Y => net00169, A => net00165, B => net00170, S => net00118);
   U86 : DMUX port map(Y => net00172, A => net00168, B => net00001, S => net00121);
   U87 : DMUX port map(Y => net00171, A => net00167, B => net00172, S => net00122);
   U88 : MUX2H port map(Y => DO(14), A => net00169, B => net00171, S => net00004);
   U89 : DMUX port map(Y => net00180, A => net00176, B => net00001, S => net00117);
   U90 : DMUX port map(Y => net00179, A => net00175, B => net00180, S => net00118);
   U91 : DMUX port map(Y => net00182, A => net00178, B => net00001, S => net00121);
   U92 : DMUX port map(Y => net00181, A => net00177, B => net00182, S => net00122);
   U93 : MUX2H port map(Y => DO(15), A => net00179, B => net00181, S => net00004);

end STRUCT_APA1kx16;


